## Created 02/07/2020
## authors: Martin Renoult and James Annan
## Correspondence: martin.renoult@misu.su.se

library(spBayes)

## Conjugate prior approach
## Require the package spBayes

## PlioMIP1 + 2 ensemble
x <- c(3.2, 3.4, 4.05, 2.8, 4.1, 3.2, 3.3, 3.1,
       3.37, 2.6,4.50, 2.29,5.3,4.3)

y <- c(1.0256042, 1.3337059, 1.9900227, 1.1576538, 2.1806774, 1.151104, 1.9331722, 1.445343,
       2.14, 0.9211941,2.1174774, 1.3736095,3.4950447,2.94250999999997)

plot(x,y)

data <- data.frame(y,x)

## p is the number of regression parameters
p <- 2
n.samples <- 100000

## Prior on mean and precision matrix
beta.prior.mean <- c(0,1)

beta.prior.precision <- .5*diag(p)

## Prior on the Inverse Gamma prior
prior.shape <- 0.5
prior.rate <- 0.5

conj <- bayesLMConjugate(y~x,data,n.samples,beta.prior.mean,beta.prior.precision,prior.shape,prior.rate)

print(c(mean(conj$p.beta.tauSq.samples[,1]),sd((conj$p.beta.tauSq.samples[,1]))))
print(c(mean(conj$p.beta.tauSq.samples[,2]),sd((conj$p.beta.tauSq.samples[,2]))))
print(c(mean(sqrt(conj$p.beta.tauSq.samples[,3])),sd((sqrt(conj$p.beta.tauSq.samples[,3])))))
